#pragma once

#include "core/sprite.h"
#include "core/point.h"
#include "core/color.h"
#include "core/rectangle.h"

#include <memory>

class ClassicSprite : public kku::Sprite
{
public:

    struct Init
    {
        std::shared_ptr<kku::Rectangle> shape;
        std::shared_ptr<kku::Rectangle> trail;
        kku::Color color;
    };

    explicit ClassicSprite(ClassicSprite::Init&& init); 
    virtual void reset() override;
    virtual void display() const override;

    virtual void setPosition(const kku::Point &position);
    virtual void setTrailPosition(const kku::Point &position);
    virtual kku::Point getPosition() const;
    virtual kku::Point getTrailPosition() const;

    virtual void setColor(const kku::Color& color);
    virtual void setTrailColor(const kku::Color& color);
    virtual kku::Color getColor() const;
    virtual kku::Color getTrailColor() const;

    std::shared_ptr<const kku::Rectangle> getRectangle() const;

protected:
    kku::Color _reset_color;
    std::shared_ptr<kku::Rectangle> _shape;
    std::shared_ptr<kku::Rectangle> _trail;
};
